

//+------------------------------------------------------------------+
//|                      OM NAMAH SIVAY                              |
//|        OM NAMAH SIVAY              OM NAMAH SIVAY                |
//|    OM NAMAH SIVAY    OM NAMAH SIVAY    OM NAMAH SIVAY            |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, OM Corp."
#property link "http://www.jatinpruthvi.co.cc"

// Include  our class
#include <Jatin_Iteration\Jatin_OBJ_1.mqh>
#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh> //include the library for obtaining information on
//--- input parameters
input int StopLoss = 30; // Stop Loss
input int TakeProfit = 100; // Take Profit
input int ADX_Period = 14; // ADX Period
input int MA_Period = 10; // Moving Average Period
input int EA_Magic = 12345; // EA Magic Number
input double Adx_Min = 22.0; // Minimum ADX Value
input double Lot = 0.1; // Lots to Trade
input int Margin_Chk = 1; // Check Margin before placing trade(0=No, 1=Yes)
input double Trd_percent = 15.0; // Percentage of Free Margin To use for Trading
input double AccountTP = 0.6;
input double AccountSL = 20;
input ENUM_TIMEFRAMES period = PERIOD_CURRENT;
input string EA_Symbols = "GBPUSD;USDCHF;GBPCHF";
input string EA_Symbols_Seperator = ";";
//--- other parameters

//+------------------------------------------------------------------+
//| Expert Global Variable                                           |
//+------------------------------------------------------------------+
MyExpert Cexpert[3]; //--- create an object of our class
MqlTradeRequest trequest; //MQL5 trade request structure to be used for sending our trade requests
MqlTradeResult tresult; //MQL5 trade result structure to be used to get our trade results
string EA_Symbols_Array[3];
int Symbol_Signal[3];
int symbol_size = 0;
ENUM_ORDER_TYPE BBS[] = { ORDER_TYPE_BUY, ORDER_TYPE_BUY, ORDER_TYPE_SELL }; // BUY BUY SELL
ENUM_ORDER_TYPE SSB[] = { ORDER_TYPE_SELL, ORDER_TYPE_SELL, ORDER_TYPE_BUY }; // SELL SELL BUY
int BBSorSSB = -1; // 1 for bbs , 2 for ssb
CPositionInfo m_Position; // structure for obtaining information of positions



string SYMBOLS_OF_PAIR[] =
{
"EURCHF;CHFJPY;EURJPY",
"GBPCHF;CHFJPY;GBPJPY",
"USDCHF;CHFJPY;USDJPY",
"EURGBP;GBPCHF;EURCHF",
"EURUSD;USDCHF;EURCHF",
"EURGBP;GBPJPY;EURJPY",
"EURGBP;GBPUSD;EURUSD",
"EURUSD;USDJPY;EURJPY",
"GBPUSD;USDCHF;GBPCHF",
"GBPUSD;USDJPY;GBPJPY", 
};

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    symbol_size = StringSplit(EA_Symbols, StringGetCharacter(EA_Symbols_Seperator, 0),EA_Symbols_Array);
    if (symbol_size != 3) {
        Alert("Provide Proper Symbols");
        return 0;
    }
    //--- Set event generation frequency
    EventSetTimer(1); // 1 second

    //--- run Initialize function
    for (int i = 0; i < symbol_size; i++) {
        Cexpert[i].doInit(ADX_Period,MA_Period); //--- set all other necessary variables for
        //our class object
        Cexpert[i].setPeriod(period); // sets the chart period/timeframe
        Cexpert[i].setSymbol(EA_Symbols_Array[i]); // sets the chart symbol/currency-pair
        Cexpert[i].setadxmin(Adx_Min); // sets the ADX miniumm value
        Cexpert[i].setLOTS(Lot); // set the Lots value
        Cexpert[i].setchkMAG(Margin_Chk); // set the margin check variable
        Cexpert[i].setTRpct(Trd_percent); // set the percentage of Free Margin for trade
        
    }

    return (0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
     ZeroMemory(trequest);
    ZeroMemory(tresult);
    //--- Termination of event generation
    EventKillTimer();
    //--- Run UnIntilialize function
    for (int i = 0; i < symbol_size; i++) {
        Cexpert[i].doUninit();
    }
}

int DayOfWeek()
{
    MqlDateTime tm;
    TimeCurrent(tm);
    return (tm.day_of_week);
}

double calculateProfit()
{
    double profit = 0;
    for (int i = 0; i < symbol_size; i++) {
        /*
   if(m_Position.Select(EA_Symbols_Array[i]) && m_Position.Magic() == EA_Magic){
           profit = profit + m_position.Profit();
    }
*/
        if (m_Position.SelectByMagic(EA_Symbols_Array[i], EA_Magic)) {
            profit = profit + m_Position.Profit();
        }
    }
    return profit;
}

void closeAllOrder()
{
    for (int i = 0; i < symbol_size; i++) {
        if (m_Position.SelectByMagic(EA_Symbols_Array[i], EA_Magic)) {
            CTrade* m_Trade = new CTrade;
            while (!m_Trade.PositionClose(EA_Symbols_Array[i], 1000))
                ;
        }
    }

    /*
  if(m_Position.Select(EA_Symbols_Array[i]) && m_Position.Magic() == EA_Magic){
          while(!m_Trade.PositionClose(EA_Symbols_Array[i],1000));
  }
  */
    /*
if(m_Position.SelectByMagic(EA_Symbols_Array[i],EA_Magic)){
   while(!m_Position.PositionClose(EA_Symbols_Array[i],1000));

}*/
    /*
   int PosTotal=OrdersTotal();
  for(int i=PosTotal-1; i>=0; i--){

    for(int j = 0 ; j< symbol_size ; j++){

      if(PositionGetSymbol(i)==EA_Symbols_Array[j]){
         if(EA_Magic==PositionGetInteger(POSITION_MAGIC))
     {
        if(PositionGetInteger(POSITION_TYPE)>1){
           ulong tkt=OrderGetTicket(i);
           CTrade *trade=new CTrade;
            trade.OrderDelete(tkt);

       }
     }
       }

}


   }

  */
}

int orderOpened()
{
    int ordOpened = 0;
    for (int i = 0; i < symbol_size; i++) {
        if (m_Position.Select(EA_Symbols_Array[i]) && m_Position.Magic() == EA_Magic) {
            ordOpened++;
        }
    }
    return ordOpened;
}

void prepareSignal()
{
    for (int i = 0; i < symbol_size; i++) {
        Symbol_Signal[i] = Cexpert[i].getBuySellSignal();
    }
}

// BUY BUY SELL
// SELL SELL BUY
// 0 - nothing , 1-Buy , 2-Sell
void prepareOrderSendType()
{
    int bbs = 0, ssb = 0;
    for (int i = 0; i < symbol_size; i++) {
        if (Symbol_Signal[i] == BBS[i]) {
            bbs++;
        }
        if (Symbol_Signal[i] == SSB[i]) {
            ssb++;
        }
        if (bbs < ssb) {
            BBSorSSB = 2;
        }
        else if (bbs > ssb) {
            BBSorSSB = 1;
        }
        else {
            BBSorSSB = -1;
        }
    }
}

void placeBBS()
{
    for (int i = 0; i < symbol_size; i++) {
        while (!openBuySell(BBS[i],EA_Symbols_Array[i])) {
        };
    }
}

void placeSSB()
{
    for (int i = 0; i < symbol_size; i++) {
        while (!openBuySell(SSB[i],EA_Symbols_Array[i])) {
        };
    }
}
//-===================== The OnTimer function
//======================================================
void OnTimer()
{
    int dayOfWeek = DayOfWeek();
    if (dayOfWeek == 0 || dayOfWeek == 6) {
        Sleep(900000); // 15 min
        return;
    }
    double acProfit = calculateProfit();
    if (acProfit > AccountTP || acProfit < AccountSL) {
        closeAllOrder();
    }

    if (orderOpened() > 0) // FUTURE DEVELOPMENT : ALL ORDERS ARE OPEN OR NOT
    {
        return;
    }

    prepareSignal();
    prepareOrderSendType();
    if (BBSorSSB == -1)
        return;

    if (BBSorSSB == 1) {
        placeBBS();
    }
    else if (BBSorSSB == 2) {
        placeSSB();
    }

}

bool openBuySell(ENUM_ORDER_TYPE otype,string symbol)
{
   

    bool result = false;
    double oprice = 0, stl = 0, tkp = 0, ask = 0, bid = 0;
    MqlTick latest_price;
    bool bidask = false;
    if (SymbolInfoTick(symbol, latest_price))
    {
        bidask = true;
    }
    int digits = (int)SymbolInfoInteger(symbol, SYMBOL_DIGITS); // number of decimal places
    double nPoint = SymbolInfoDouble(symbol, SYMBOL_POINT);
    if (otype == ORDER_TYPE_BUY) {
        ask = bidask ? latest_price.ask : SymbolInfoDouble(symbol, SYMBOL_ASK);
        oprice = NormalizeDouble(ask, digits); // current Ask price
       // stl = NormalizeDouble(ask - STP * nPoint, digits); // Stop Loss
       // tkp = NormalizeDouble(ask + TKP * nPoint, digits); // Take profit
    }
    else if (otype == ORDER_TYPE_SELL) {
        bid = bidask ? latest_price.bid : SymbolInfoDouble(symbol, SYMBOL_BID);
        oprice = NormalizeDouble(bid, digits); // Current Bid price
       // stl = NormalizeDouble(bid + STP * nPoint, digits); // Stop Loss
       // tkp = NormalizeDouble(bid - TKP * nPoint, digits); // Take Profit
    }
    else {
        Print("Invalid Order Type");
        return result;
    }

    trequest.action = TRADE_ACTION_DEAL;
    trequest.type = otype;
    trequest.volume = Lot;
    trequest.price = oprice;
    trequest.sl = 0;
    trequest.tp = 0;
    trequest.deviation = 1000;
    trequest.magic = EA_Magic;
    trequest.symbol = symbol;
    trequest.type_filling = ORDER_FILLING_FOK;

    OrderSend(trequest, tresult);
    if (tresult.retcode == 10009 || tresult.retcode == 10008) //Request successfully completed
    {
        result = true;
        Print("A Buy order has been successfully placed with Ticket#:", tresult.order, "!!");
    }
    else
    {
        result = false;
        Print("The Buy order request could not be completed#:", GetLastError(), "!!");
       // Errormsg = "The Buy order request could not be completed";
       // Errcode = GetLastError();
       // showError(Errormsg, Errcode);
    }
    return result;
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

void OnTick() {
}

//+------------------------------------------------------------------+
